        PROCESSOR 6502

; Stay Frosty
; Last Update: November 11, 2007
; Design by:   Nathan Strum
; Program by:  Darrell Spice, Jr.

TIA_BASE_READ_ADDRESS = $30
        include VCS.H
        include macro.h
        include graphics.h
                
PLATFORM_COLOR = $74 ; NTSC purple        
; usage LEVEL_SECTION section, last
; section = 0 thru 4 for 5 sections
        MAC LEVEL_SECTION 
.SEC    SET {1}
        ldy Heights+.SEC              ; 3    load Y with height of current section
        lda #$9A
        sta COLUPF
        lda (FrostyImagePtr+.SEC*2),y ; 5
        and (FrostyMaskPtr+.SEC*2),y  ; 5
        tax
        lda (FrostyColorPtr+.SEC*2),y ;
        tay
        lda FireBallX+.SEC*2
        jsr PosPlayer1
        ldy Heights+.SEC
        dey
        lda (FrostyImagePtr+.SEC*2),y ; 5
        and (FrostyMaskPtr+.SEC*2),y  ; 5
        sta GRP0        
        lda (FrostyColorPtr+.SEC*2),y ; 5  8
        sta COLUP0                    ; 3 11        
        dey

.airLoop
        lda (FrostyImagePtr+.SEC*2),y ; 5
        and (FrostyMaskPtr+.SEC*2),y  ; 5
        sta WSYNC                     ; 3
        sta GRP0                      ; 3
        lda (FrostyColorPtr+.SEC*2),y ; 5  8
        sta COLUP0                    ; 3 11
        lda (FireImagePtr+.SEC*2),y   ; 5 16
        sta GRP1                      ; 3 19
        dey                           ; 2 21
        cpy #13                       ; 2 23
        bne .airLoop                  ; 3 26
        SLEEP 30                      ;30 56 

.iceLoop
        lda (FrostyImagePtr+.SEC*2),y ; 5
        and (FrostyMaskPtr+.SEC*2),y  ; 5 
        sta WSYNC                     ; 3
        sta GRP0                      ; 3
        lda (FrostyColorPtr+.SEC*2),y ; 5
        sta COLUP0                    ; 3
        lda (FireImagePtr+.SEC*2),y   ; 5
        sta GRP1                      ; 3
        ldx IceData+.SEC*4            ; 3
        stx PF1                       ; 3
        ldx IceData+.SEC*4+1          ; 3
        stx PF2                       ; 3
        ldx IceData+.SEC*4+2          ; 3
        SLEEP 9                       ; 9
        dey                           ; 2
        stx PF2                       ; 3
        ldx IceData+.SEC*4+3          ; 3
        stx PF1                       ; 3
        cpy #5                        ; 2
        bne .iceLoop                  ; 3
        
 if .SEC = 0
.platformLoop
        ldx #$64                      ;
        lda #0
        sta WSYNC                     ;
        sta GRP0
        sta GRP1
        stx COLUPF
        ldx #255
        stx PF0
        stx PF1
        stx PF2
        dey
        cpy #1                        ; 2
        bne .platformLoop             ; 3
 else
        lda (FrostyImagePtr+.SEC*2),y ; 5
        and (FrostyMaskPtr+.SEC*2),y  ; 5
        ldx #$64                      ; 2
        sta WSYNC                     ; 3
        stx COLUPF                    ; 3 
        sta GRP0                      ; 3
        lda (FrostyColorPtr+.SEC*2),y ; 5
        sta COLUP0                    ; 3
        lda #0                        ; 2
        sta GRP1                      ; 3
        ldx Platforms+.SEC*4-4        ; 3
        stx PF1                       ; 3
        ldx Platforms+.SEC*4-4+1      ; 3
        stx PF2                       ; 3 
        ldx Platforms+.SEC*4-4+2      ; 3
        SLEEP 9                       ; 9
        dey                           ; 2
        stx PF2                       ; 3
        ldx Platforms+.SEC*4-4+3      ; 3
        stx PF1                       ; 3
        
.platformLoop
        lda (FrostyImagePtr+.SEC*2),y ; 5
        and (FrostyMaskPtr+.SEC*2),y  ; 5
        sta WSYNC                     ; 3
        sta GRP0                      ; 3
        lda (FrostyColorPtr+.SEC*2),y ; 5
        sta COLUP0                    ; 3
        ldx Platforms+.SEC*4-4        ; 3
        stx PF1                       ; 3
        ldx Platforms+.SEC*4-4+1      ; 3
        stx PF2                       ; 3
        ldx Platforms+.SEC*4-4+2      ; 3
        SLEEP 17                      ;17
        dey                           ; 2        
        stx PF2                       ; 3
        ldx Platforms+.SEC*4-4+3      ; 3
        stx PF1                       ; 3
        cpy #1                        ; 2
        bne .platformLoop             ; 3
 ENDIF        

        lda (FrostyImagePtr+.SEC*2),y ; 5
        and (FrostyMaskPtr+.SEC*2),y  ; 5
        sta WSYNC                     ; 3
        sta GRP0                      ; 3
        lda (FrostyColorPtr+.SEC*2),y ; 5
        sta COLUP0                    ; 3
        lda #0
        sta PF0
        sta PF1
        sta PF2
        ENDM
        
OVERSCAN_DELAY = $1a

HMOVE_L7          =  $70
HMOVE_L6          =  $60
HMOVE_L5          =  $50
HMOVE_L4          =  $40
HMOVE_L3          =  $30
HMOVE_L2          =  $20
HMOVE_L1          =  $10
HMOVE_0           =  $00
HMOVE_R1          =  $F0
HMOVE_R2          =  $E0
HMOVE_R3          =  $D0
HMOVE_R4          =  $C0
HMOVE_R5          =  $B
HMOVE_R6          =  $A0
HMOVE_R7          =  $90
HMOVE_R8          =  $80


        SEG.U VARS
        ORG $80
; song player variables for main menu- note song player scratch variables
Frame             ds 1

FROSTYHEIGHT = 26
FrostyX           ds 1
FrostyY           ds 1
FrostyNoseY       ds 1
FrostyControl     ds 1 ; 76543210
                       ; 5 = 0 facing right, 1 = facing left
                       ; 43210 - 0 to 31, jump height

ReserveLives      ds 1

; moon or sun
CELESTIALHEIGHT = 8
CelestialX        ds 1
CelestialY        ds 1
CelestialImagePtr ds 2


Score             ds 3

Level             ds 1    ; What level are we on?

Temp              ds 1

SECTIONS = 5 ; sections 0-4, 0 is bottom area just above score
LEVEL_BYTES_PER_SECTION = 11
Heights          ds 1*SECTIONS    ; heights of the levels
FireBallX        ds 2*SECTIONS    ; fireball positions, 2 per section
IceData          ds 4*SECTIONS    ; ice blocks
Platforms        ds 4*SECTIONS-4    ; platforms 
                                
FrostyImagePtr   ds 2*SECTIONS
FrostyMaskPtr    ds 2*SECTIONS
FrostyColorPtr   ds 2*SECTIONS
FireImagePtr     ds 2*SECTIONS

G48      EQU FrostyImagePtr ; reuse of RAM, 12 bytes
G48temp1 EQU FireImagePtr   ; reuse of RAM, 1 byte - lines remaining during Show48graphic
G48temp2 EQU FireImagePtr+1 ; reuse of RAM, 1 byte - holds temp image data during Show48graphic

LevelDataPtr EQU FrostyImagePtr ; reuse of RAM, 2 bytes when initing a level




 echo "----",($00FE - *) , "bytes of RAM left"
; $FE - $FF stack
; reuse of stack RAM - no JSRs can be called when these are used

; end reuse of stack RAM


        SEG CODE
        
        ORG $F000
InitSystem
        cmp SelectLastBank   ; inits system then goes to the menu
        jmp InitSystemCode   ; jump to Main Menu

InitSystemCode
InitFrostyCode    ; starting point of this game
        CLEAN_START
        lda #$7b
        sta CelestialX
        lda #$11
        sta CelestialY
;        lda #$18 ; NTSC Yellow
;        sta CelestialColor
        lda #<SunGraphic
        sta CelestialImagePtr
        lda #>SunGraphic
        sta CelestialImagePtr+1
        
        lda #0
        sta Score
        sta Score+1
        sta Score+2
        
        lda #50
        sta FrostyX
        sta FrostyY
        
        lda #1
        sta Level     ; set initial level
        jsr PrepLevel ; load level 1 data
        
        jmp VerticalBlankCode
        
PosObject   ; A holds X value
        sec ; X holds object, 0=P0, 1=P1, 2=M0, 3=M1, 4=Ball
        sta WSYNC
DivideLoop
        sbc #15        ; 2
        bcs DivideLoop ; 2    4
        eor #7         ; 2    6
        asl            ; 2    8
        asl            ; 2   10
        asl            ; 2   12
        asl            ; 2   14
        sta.wx HMP0,X  ; 5   19
        sta RESP0,X    ; 4   23 <- set object position
        sta WSYNC
        sta HMOVE
        rts

        
PosPlayer1         ; A holds X value
        sec        ; X holds GRP0
        sta WSYNC  ; Y holds COLUP0
        stx GRP0       ; 3
        sty COLUP0     ; 3    6
DivideLoop1
        sbc #15        ; 2    8
        bcs DivideLoop1; 2   10
        eor #7         ; 2   12
        asl            ; 2   14
        asl            ; 2   16
        asl            ; 2   18
        asl            ; 2   20
        sta RESP1      ; 2   23 <- set object position
        sta HMP1       ; 3   26
        sta WSYNC
        sta HMOVE
        rts        
        
        
VerticalBlankCode
        lda #$02
        sta WSYNC
        sta VSYNC  ; 3   start vertical sync, D1=1
        sta VBLANK ; 3 6 start vertical blank, D1=1
        lda #$2C   ; 2 8 set timer for end of Vertical Blank
        sta TIM64T
        sta WSYNC  ; 1st line of vertical sync
        inc Frame  ; 5
        sta WSYNC  ; 2nd line of vertical sync
        lda #0     ; 2
        sta WSYNC  ; 3rd line of vertical sync
        sta VSYNC  ; stop vertical sync, D1 = 0
        
        ; game code here
        

        lda Frame
        and #11
        bne DoneMoving        
; test moving platforms        
        lda Temp
        bne MovingDown
        dec Heights+2
        inc Heights+3
        lda Heights+3
        cmp #35
        bne DoneMoving
        sta Temp ; change direction
MovingDown        
        inc Heights+2
        dec Heights+3
        lda Heights+3
        cmp #25
        bne DoneMoving
        lda #0        
        sta Temp
        
DoneMoving        


        
        ;test sun in various X positions
        lda Frame
        lsr
        clc        
        adc #12
        sta CelestialX
        ; end test sun

        lda CelestialX
        ldx #0 ; sun/moon in Sprite 0
        jsr PosObject
        ;lda CelestialColor
        lda #$18 ; NTSC Yellow
        sta COLUP0
        lda #15
        sta COLUPF
        lda #$86 ; NTSC Blue
        sta COLUBK ;
        lda #1
        sta CTRLPF ; reflected playfield for HORIZON
        lda #0
        sta HMP0        
        
        lda FrostyControl
        lda FrostyX
        cmp CelestialX
        bcc FacingLeft
        lda #%00001000
        sta REFP0
FacingLeft   
        ; test ReserveLives display
        lda Frame
        eor #$FF
        lsr
        lsr
        lsr
        lsr
        lsr
        and #%11
        sta ReserveLives
        
        ; ; test score
        ; clc
        ; sed
        ; lda #$01
        ; adc Score+2
        ; sta Score+2
        ; lda #0
        ; adc Score+1
        ; sta Score+1
        ; lda #0
        ; adc Score
        ; sta Score
        ; cld
        
        ; prep Frosty Y data
        SET_POINTER FrostyImagePtr, FrostyGraphic
        SET_POINTER FrostyColorPtr, FrostyColors        
        SET_POINTER FrostyMaskPtr, FrostyMask
        SET_POINTER FireImagePtr, Fireball1
        SET_POINTER FireImagePtr+2, Fireball1
        SET_POINTER FireImagePtr+4, Fireball1
        SET_POINTER FireImagePtr+6, Fireball1
        SET_POINTER FireImagePtr+8, Fireball1
        sec
        lda FrostyImagePtr
        sbc FrostyY
        sta FrostyImagePtr
        lda FrostyImagePtr+1
        sbc #0
        sta FrostyImagePtr+1
        
        sec
        lda FrostyColorPtr
        sbc FrostyY
        sta FrostyColorPtr
        lda FrostyColorPtr+1
        sbc #0
        sta FrostyColorPtr+1
        
        sec
        lda FrostyMaskPtr
        sbc FrostyY
        sta FrostyMaskPtr
        lda FrostyMaskPtr+1
        sbc #0
        sta FrostyMaskPtr+1        
        
        
        
; Prep Frosty Pointers for each section

        ldx #0
        ldy #0
pfLoop        
        clc
        lda FrostyImagePtr,y
        adc Heights,x
        iny ; 1
        iny ; 2
        sta FrostyImagePtr,y
        dey ; 1
        lda FrostyImagePtr,y
        adc #0
        iny ; 2
        iny ; 3
        sta FrostyImagePtr,y
        
        dey ; 2
        dey ; 1
        dey ; 0
        clc
        lda FrostyColorPtr,y
        adc Heights,x
        iny ; 1
        iny ; 2
        sta FrostyColorPtr,y
        dey ; 1
        lda FrostyColorPtr,y
        adc #0
        iny ; 2
        iny ; 3
        sta FrostyColorPtr,y              
        
        dey ; 2
        dey ; 1
        dey ; 0
        clc
        lda FrostyMaskPtr,y
        adc Heights,x
        iny ; 1
        iny ; 2
        sta FrostyMaskPtr,y
        dey ; 1
        lda FrostyMaskPtr,y
        adc #0
        iny ; 2
        iny ; 3
        sta FrostyMaskPtr,y           
        
        dey ; 2
        inx        
        cpx #SECTIONS-1
        bcc pfLoop

; tweek Frosty pointers so no page breaks occur
        ldy #1
MaskLoop        
        lda FrostyMaskPtr,y
        cmp #>BlankGraphic
        beq MaskCheck2
        lda #>BlankGraphic
        sta FrostyMaskPtr,y     
        sta FrostyImagePtr,y
        sta FrostyColorPtr,y
        dey
        lda #0
        sta FrostyMaskPtr,y
        sta FrostyImagePtr,y
        sta FrostyColorPtr,y
        iny
        bne NextMask
MaskCheck2
        dey
        lda FrostyMaskPtr,y
        cmp #<FrostyMask
        bcc NextMask2
        lda #0
        sta FrostyMaskPtr,y
        sta FrostyImagePtr,y
        sta FrostyColorPtr,y
        iny
        lda #>BlankGraphic
        sta FrostyMaskPtr,y
        sta FrostyImagePtr,y
        sta FrostyColorPtr,y
        bne NextMask
NextMask2        
        iny
NextMask
        iny
        iny
        cpy #SECTIONS*2
        bcc MaskLoop
                
        lda #$20
        sta NUSIZ1           ; 3  25
        ldx #$38 ; NTSC Orange for nose
        stx COLUP1

; flicker fireballs
        ldy #0
        ldx #1
FlickerLoop
        lda FireBallX,y
        pha
        lda FireBallX,x
        sta FireBallX,y
        pla
        sta FireBallX,x
        iny
        iny
        inx
        inx
        cpy #SECTIONS*2
        bcc FlickerLoop
        
; test fireball range
        lda Frame
        and #%00000001
        bne SkipMove
        ldx FireBallX
        inx
        cpx #147
        bne .skipFBx
        ldx #0
.skipFBx 
        stx FireBallX
        stx Score
        
SkipMove
        jmp KernelCode
        
.skipCelestialDraw
        lda #0
        beq .celestialDraw
        
KernelCode

.VblankWait
        lda INTIM
        bpl .VblankWait
        lda #0
        sta VBLANK ; turn on video output
        sta WSYNC
        
        ldx #16
.HorizonLoop        
        sta WSYNC
        cpx #8                        ; 2
        bcs .skipHills                ; 2  4
        lda HillColor,x
        sta COLUPF
        lda Hill0,x                   ; 4  8
        sta PF0                       ; 3 11
        lda Hill1,x                   ; 4 15
        sta PF1                       ; 3 18
        lda Hill2,x                   ; 4 22
        sta PF2                       ; 3 25
.skipHills     
        txa
        sec
        sbc CelestialY
        adc #CELESTIALHEIGHT
        bcc .skipCelestialDraw
        tay
        lda (CelestialImagePtr),y     ; 
.celestialDraw        
        sta GRP0                      ;
        dex                           ; 2 44
        bpl .HorizonLoop              ; 2 46
        inx
        stx WSYNC
;        stx CTRLPF ; repeated playfield for game screen
        stx COLUBK
        stx PF0
        stx PF1
        stx PF2
        lda FrostyControl
        lsr
        lsr
        sta REFP0   ; set Frosty facing left or right
        lda FrostyX
        ldx #0
        jsr PosObject
        SLEEP 20
        lda #0
        sta HMP0

        LEVEL_SECTION 4
        LEVEL_SECTION 3
        LEVEL_SECTION 2
        LEVEL_SECTION 1        
        LEVEL_SECTION 0
        
        
; display SCORE and Reserve Lives
        sta WSYNC
        lda #0               ; 2
        sta GRP0             ; 3   5
        sta HMP1             ; 3   8
        sta PF0              ; 3  11
        sta PF1              ; 3  14
        sta PF2              ; 3  17
        lda #3               ; 2  19
        sta NUSIZ0           ; 3  22
        sta NUSIZ1           ; 3  25
        sta VDELP0           ; 3  28
        sta VDELP1           ; 3  31
        lda #HMOVE_R1             ; 2  33
        sta HMP0             ; 3  36 x adjust for P0  
        sta RESP0            ; 3  39 set x for P0
        sta RESP1            ; 3  42 set x for P1
        sta WSYNC
        SLEEP 38             ; 38
        sta RESM1            ;  3  41 set x for M1 - used to draw nose in lives remaining
        sta WSYNC
        sta HMOVE   ; fine adjust for P0
        lda #15 ; WHITE NTSC & PAL
        sta COLUP0
        sta COLUP1
        lda #0
        sta HMP0        
        sta REFP0       ; reset in case Frosty was facing left
        
; Load G48 with SCORE graphics        
        lda #>ZeroGraphic
        sta G48+1
        sta G48+3
        sta G48+5
        sta G48+7
        sta G48+9
        sta G48+11
        
        lda Score
        and #$F0
        lsr
        sta G48
        lda Score
        and #$0f
        asl
        asl
        asl
        sta G48+2
        
        lda Score+1
        and #$F0
        lsr
        sta G48+4
        lda Score+1
        and #$0F
        asl
        asl
        asl
        sta G48+6
        
        lda Score+2
        and #$F0
        lsr
        sta G48+8
        lda Score+2
        and #$0F
        asl
        asl
        asl
        sta G48+10
        
        sta WSYNC                 
        ldx #0
BlankZeroLoop 
        lda G48,x
        bne BZLdone
        inx
        lda #>BlankGraphic
        sta G48,x
        inx
        cpx #10
        bcc BlankZeroLoop
BZLdone    
        SLEEP 10
        inx
        inx
        cpx #10
        bcc BZLdone

        ; show score
        ldy #7        
Show48graphic 
        ; call with Y holding the lines-1 to show
        ; G48 thru G48+$B must be preloaded with pointers to the
        ; 48 pixel graphic image
        STY G48temp1
        sta WSYNC
.graphicLoop
        ldy G48temp1         ;+3  63  189
        lda (G48),y          ;+5  68  204
        sta GRP0             ;+3  71  213      D1     --      --     --
        sta WSYNC            ;go
        lda (G48+$2),y       ;+5   5   15
        sta GRP1             ;+3   8   24      D1     D1      D2     --
        lda (G48+$4),y       ;+5  13   39
        sta GRP0             ;+3  16   48      D3     D1      D2     D2
        lda (G48+$6),y       ;+5  21   63
        sta G48temp2         ;+3  24   72
        lda (G48+$8),y       ;+5  29   87
        tax                  ;+2  31   93
        lda (G48+$A),y       ;+5  36  108
        tay                  ;+2  38  114
        lda G48temp2         ;+3  41  123              !
        sta GRP1             ;+3  44  132      D3     D3      D4     D2!
        stx GRP0             ;+3  47  141      D5     D3!     D4     D4
        sty GRP1             ;+3  50  150      D5     D5      D6     D4!
        sta GRP0             ;+3  53  159      D4*    D5!     D6     D6
        dec G48temp1         ;+5  58  174                             !
        bpl .graphicLoop     ;+2  60  180
        lda #0
        sta GRP0
        sta GRP1
        sta GRP0
        sta GRP1
        sta WSYNC
        
        sta WSYNC
        ldx #0 ; black for nose when no lives remaining        
        lda ReserveLives
        beq Only2left  ; doesn't matter - graphic will be blank
        ldx #$38 ; NTSC Orange for nose
        cmp #2
        bcc Only1left
        beq Only2left
        lda #$23       ; show 3 close
        .byte $2c
Only2left        
        lda #$21       ; show 2 close
        .byte $2c
Only1left        
        lda #$20       ; show 1
        sta NUSIZ0
        stx COLUP1
        
        sta NUSIZ1
        lda #0
        sta VDELP0           ; 3  28
        sta VDELP1           ; 3  31          
        
        lda ReserveLives
        bne AtLeast1left
        lda #<BlankGraphic
        .byte $2c ; sucks up the next command
AtLeast1left        
        lda #<LivesGraphic
        sta G48
        lda #>LivesGraphic
        sta G48+1

        ldx #ENAM1
        txs
        ldy #12
.graphicLoop2
        lda LivesColor,y
        sta WSYNC
        sta COLUP0
        lda (G48),y
        sta GRP0
        cpy #3 ; enable carrot nose on line 3
        php
        pla
        dey
        bpl .graphicLoop2
        lda #0
        sta WSYNC
        sta GRP0
        sta NUSIZ0           ; 3  22
        ldx #$FF
        txs        

        
        
OverScanCode
        sta WSYNC
        lda #2
        sta VBLANK ; turn off video output
        lda #OVERSCAN_DELAY
        sta TIM64T
        
        lda SWCHA
        bmi SkipRight
        inc FrostyX
        tay
        lda FrostyControl
        and #%11011111     ; set facing right 
        sta FrostyControl
        tya
SkipRight
        rol
        bmi SkipLeft
        dec FrostyX
        tay
        lda FrostyControl
        ora #%00100000     ; set facing left
        sta FrostyControl
        tya
SkipLeft
        rol
        bmi SkipDown
        dec FrostyY
SkipDown
        rol
        bmi SkipUp
        inc FrostyY
SkipUp     

; check X and Y values, prevening wrap-around
        lda FrostyX
        cmp #153
        bne .nextXcheck
        lda #152
        bne .saveNewX
.nextXcheck
        cmp #255
        bne .noXadjust
        lda #0
.saveNewX        
        sta FrostyX
.noXadjust        
        lda FrostyY
        cmp #$1f
        bne .nextYcheck
        lda #$20
        bne .saveNewY
.nextYcheck
        cmp #$96
        bne .noYadjust
        lda #$95
.saveNewY
        sta FrostyY
.noYadjust        
        
        
 
        
.OscanWait
        lda SWCHB
        eor #$FF
        and #%11
        bne SelectOrReset
        lda INTIM
        bpl .OscanWait
        jmp VerticalBlankCode
        
SelectOrReset
        jmp InitFrostyCode
        
        
PrepLevel SUBROUTINE
        SET_POINTER LevelDataPtr, Level1 ; loading just level 1 for testing
        ldy #SECTIONS*LEVEL_BYTES_PER_SECTION-4-1 ; -2 for the 2 unused platform bytes
.plLoop        
        lda (LevelDataPtr),y
        sta Heights,y
        dey
        bpl .plLoop
        rts
        
SunGraphic
        .byte zz___XX___
        .byte zz__X__X__
        .byte zz_X_XX_X_
        .byte zz_XXXXXX_
        .byte zz_X_X_XX_
        .byte zz_X_X_XX_
        .byte zz__XXXX__
        .byte zz___XX___
        
HillColor
        .byte 4,4,8,8,15,15,15,15
        
        
Hill0
        .byte zzXXXX____ ; 0
        .byte zzXXXX____ ; 1
        .byte zzXXXX____ ; 2
        .byte zzXXXX____ ; 3
        .byte zzXXXX____ ; 4
        .byte zzXXX_____ ; 5
        .byte zzXX______ ; 6
        .byte zzX_______ ; 7
        
Hill1
        .byte zzXXXXXXXX ; 0
        .byte zzXXXXXXXX ; 1
        .byte zzXXXXXXXX ; 2
        .byte zzXXXXXXXX ; 3
        .byte zzXXXXXXX_ ; 4
        .byte zzXXXXXXX_ ; 5
        .byte zzX_XXXX__ ; 6
        .byte zz___XX___ ; 7
        
        
        
Hill2   
        .byte zzXXXXXXXX ; 0
        .byte zz_XXXXXXX ; 1
        .byte zz__XXXXXX ; 2
        .byte zz___XXXX_ ; 3
        .byte zz____XX__ ; 4
        .byte zz________ ; 5
        .byte zz________ ; 6
        .byte zz________ ; 7
        
        align 256
        
Level1 ; section 4's height must be 31 for Frosty to fit on the platform
        .byte 29,30,29,29,31 ; section heights add up to 148
        .byte 80, 120 ; section 0 fireballs
        .byte 50, 120 ; section 1 fireballs
        .byte 30, 100 ; section 2 fireballs
        .byte 20, 60 ; section 3 fireballs
        .byte 100, 130 ; section 4 fireballs
        .byte zzXX_XX_XX, zzX_XX_XX_, zzX_XX_XX_,zzXX_XX_XX ; Section 0 ice
        .byte 0,255,0,255 ; Section 1 ice
        .byte 255,0,255,0 ; Section 2 ice
        .byte 255,255,0,0 ; Section 3 ice
        .byte 0,0,255,255 ; Section 4 ice
        
        .byte 0,255,0,255 ; Section 1 platform
        .byte 255,0,255,0 ; Section 2 platform
        .byte 255,255,0,0 ; Section 3 platform
        .byte 0,0,255,255 ; Section 4 platform
        ; no platform 5 - bottom of screen is fully on
        
        
        align 256
BlankGraphic
        repeat 50 ; 148-26 
        .byte 0
        repend        
        repeat 26        
        .byte $ff
        repend
FrostyMask        
        repeat 50 ; 148-26
        .byte 0
        repend

LivesGraphic
        .byte zz___XX___ ; 0
        .byte zz__X__X__ ; 1
        .byte zz_X_XX_X_ ; 2
        .byte zz_XXX____ ; 3  ; gap for nose drawn by missile 1
        .byte zz_XX_X_X_ ; 4
        .byte zz_XX_X_X_ ; 5
        .byte zz__XXXX__ ; 6
        .byte zz___XX___ ; 7
        .byte zz__XXXX__ ; 8
        .byte zz___XX___ ; 9
        .byte zz___XX___ ; 10
        .byte zz___XX___ ; 11
        .byte zz___XX___ ; 12

LivesColor
        .byte 15,15,15,15,15,15,15,15,4,$42,4,4,6
        
        .byte zz__XXXX__ ; 0
        .byte zz_XXXXXX_ ; 1
        .byte zzXXXXXXXX ; 2
        .byte zzXXXXXXXX ; 3
        .byte zzXXXXXXXX ; 4
        .byte zzXXXXXXXX ; 5
        .byte zzXXXX_XXX ; 6
        .byte zz_XXXXXX_ ; 7
        .byte zz__XXXX__ ; 8
        .byte zz_XXXXXX_ ; 9
        .byte zz_XXX_XX_ ; 10
        .byte zz_XXXXXX_ ; 11
        .byte zz_XXXXXX_ ; 12
        .byte zz_XXX_XX_ ; 13
        .byte zz__XXXX__ ; 14
        .byte zz___XX___ ; 15
        .byte zz__X__X__ ; 16
        .byte zz__XXXX__ ; 17
        .byte zz__X_X___ ; 18
        .byte zz__XXXX__ ; 19
        .byte zz___XX___ ; 20
        .byte zz__XXXX__ ; 21
        .byte zz___XX___ ; 22
        .byte zz___XX___ ; 23
        .byte zz___XX___ ; 24
        .byte zz___XX___ ; 25
FrostyGraphic
        
        .byte 8   ; 0
        .byte 10  ; 1
        .byte 12  ; 2
        .byte 12  ; 3
        .byte 14  ; 4
        .byte 14  ; 5
        .byte 14  ; 6
        .byte 12  ; 7
        .byte 8   ; 8
        .byte 10  ; 9
        .byte 12  ; 10
        .byte 14  ; 11
        .byte 14  ; 12
        .byte 14  ; 13
        .byte 12  ; 14
        .byte 10  ; 15
        .byte 12  ; 16
        .byte 14  ; 17
        .byte 14  ; 18
        .byte 14  ; 19
        .byte 10  ; 20
        .byte 4   ; 21
        .byte $42 ; 22 NTSC red
        .byte 4   ; 23
        .byte 4   ; 24
        .byte 6   ; 25        
FrostyColors    
        
        align 256
ZeroGraphic  
        .byte zz___XX___ ; 0
        .byte zz__X__X__ ; 1
        .byte zz_X____X_ ; 2
        .byte zz_X____X_ ; 3
        .byte zz_X____X_ ; 4
        .byte zz_X____X_ ; 5
        .byte zz__X__X__ ; 6
        .byte zz___XX___ ; 7

OneGraphic
        .byte zz__XXXXX_ ; 0
        .byte zz____X___ ; 1
        .byte zz____X___ ; 2
        .byte zz____X___ ; 3
        .byte zz____X___ ; 4
        .byte zz__X_X___ ; 5
        .byte zz___XX___ ; 6
        .byte zz____X___ ; 7
        
TwoGraphic
        .byte zz_XXXXXX_ ; 0
        .byte zz_X______ ; 1
        .byte zz_X______ ; 2
        .byte zz__X_____ ; 3
        .byte zz___XX___ ; 4
        .byte zz_____X__ ; 5
        .byte zz_X____X_ ; 6
        .byte zz__XXXX__ ; 7
        
ThreeGraphic
        .byte zzXXXXX___ ; 0
        .byte zz___XXX__ ; 1
        .byte zz____XX__ ; 2
        .byte zz___XXX__ ; 3
        .byte zz__XXX___ ; 4
        .byte zz____XX__ ; 5
        .byte zz_XX__XX_ ; 6
        .byte zz__XXXX__ ; 7
        
FourGraphic
        .byte zz____X___ ; 0
        .byte zz____X___ ; 1
        .byte zz____X___ ; 2
        .byte zz____X___ ; 3
        .byte zz_XXXXXX_ ; 4
        .byte zz__X_X___ ; 5
        .byte zz___XX___ ; 6
        .byte zz____X___ ; 7
        
FiveGraphic
        .byte zzXXXXX___ ; 0
        .byte zz____XX__ ; 1
        .byte zz_____X__ ; 2
        .byte zz____XX__ ; 3
        .byte zz_XXXXX__ ; 4
        .byte zz_XXX____ ; 5
        .byte zz_XX_____ ; 6
        .byte zz__XXXXX_ ; 7

SixGraphic
        .byte zz___XX___ ; 0
        .byte zz__X__X__ ; 1
        .byte zz_X____X_ ; 2
        .byte zz_XX__X__ ; 3
        .byte zz_X_XX___ ; 4
        .byte zz_X______ ; 5
        .byte zz__X__X__ ; 6
        .byte zz___XX___ ; 7
        
SevenGraphic
        .byte zzXX______ ; 0
        .byte zz_XX_____ ; 1
        .byte zz__XX____ ; 2
        .byte zz__XX____ ; 3
        .byte zz___XX___ ; 4
        .byte zz___XX___ ; 5
        .byte zz____XX__ ; 6
        .byte zz_XXXXXX_ ; 7
        
EightGraphic
        .byte zz___XX___ ; 0
        .byte zz__X__X__ ; 1
        .byte zz_X____X_ ; 2
        .byte zz_X____X_ ; 3
        .byte zz__XXXX__ ; 4
        .byte zz_X____X_ ; 5
        .byte zz__X__X__ ; 6
        .byte zz___XX___ ; 7
        
NineGraphic
        .byte zz___XX___ ; 0
        .byte zz__X__X__ ; 1
        .byte zz______X_ ; 2
        .byte zz___XX_X_ ; 3
        .byte zz__X__XX_ ; 4
        .byte zz_X____X_ ; 5
        .byte zz__X__X__ ; 6
        .byte zz___XX___ ; 7
        
Agraphic
        .byte zz_X____X_ ; 0
        .byte zz_X____X_ ; 1
        .byte zz_X____X_ ; 2
        .byte zz_X____X_ ; 3
        .byte zz_XXXXXX_ ; 4
        .byte zz_X____X_ ; 5
        .byte zz__X__X__ ; 6
        .byte zz___XX___ ; 7        

Bgraphic
        .byte zz_XXXXX__ ; 0
        .byte zz_X____X_ ; 1
        .byte zz_X____X_ ; 2
        .byte zz_X____X_ ; 3
        .byte zz_XXXXX__ ; 4
        .byte zz_X____X_ ; 5
        .byte zz_X____X_ ; 6
        .byte zz_XXXXX__ ; 7        
Cgraphic
        .byte zz__XXXX__ ; 0
        .byte zz_X____X_ ; 1
        .byte zz_X______ ; 2
        .byte zz_X______ ; 3
        .byte zz_X______ ; 4
        .byte zz_X______ ; 5
        .byte zz_X____X_ ; 6
        .byte zz__XXXX__ ; 7        
Dgraphic
        .byte zz_XXXXX__ ; 0
        .byte zz_X____X_ ; 1
        .byte zz_X____X_ ; 2
        .byte zz_X____X_ ; 3
        .byte zz_X____X_ ; 4
        .byte zz_X____X_ ; 5
        .byte zz_X____X_ ; 6
        .byte zz_XXXXX__ ; 7        
Egraphic
        .byte zz_XXXXXX_ ; 0
        .byte zz_X______ ; 1
        .byte zz_X______ ; 2
        .byte zz_X______ ; 3
        .byte zz_XXXXXX_ ; 4
        .byte zz_X______ ; 5
        .byte zz_X______ ; 6
        .byte zz_XXXXXX_ ; 7        
Fgraphic
        .byte zz_X______ ; 0
        .byte zz_X______ ; 1
        .byte zz_X______ ; 2
        .byte zz_X______ ; 3
        .byte zz_XXXXXX_ ; 4
        .byte zz_X______ ; 5
        .byte zz_X______ ; 6
        .byte zz_XXXXXX_ ; 7        
        
IceColor
        .byte 15, 15,15,15,15,15, $a2, $aa, $aa, $ae
        
Fireball1
        .byte 0,0,0,0,0,0
        .byte zz__XXX___
        .byte zz__XXXX__
        .byte zz_XXXXXX_
        .byte zzXXXXXXX_
        .byte zzXXXXXXX_
        .byte zzX_X_XXX_
        .byte zzX_X_XXX_
        .byte zzXXXXXXX_
        .byte zzXXXXX___
        .byte zz_XXXX___
        .byte zz_XXXXX__
        .byte zz_X_X_X__
        .byte zz_X_X_X__
        .byte zz___X____
        .byte zz_X_X____
        .byte zz__X_X___
        .byte zz____X___
        .byte 0,0,0,0,0,0,0,0,0,0

        


        echo "----",($FFF4 - *) , "bytes of ROM left"
        ORG $FFF4       ; assuming 16K or 32K
SelectBank1 .byte $00
SelectBank2 .byte $00
SelectBank3 .byte $00
SelectBank4 .byte $00
SelectBank5 .byte $00
SelectBank6 .byte $00  ; SelectLastBank16K
SelectBank7 .byte $00
SelectLastBank .byte $00
;       .word InitSystem ; NMI and 8 overlap NMI
        .word InitSystem ; RESET
        .word InitSystem ; IRQ
